<template>
  <el-dialog v-model="props.modelValue" title="编辑网站tdk" width="900px" @closed="closeDialog" @open="openDialog">
    <el-form ref="formRef" :model="formData" :rules="rules">
      <el-row>


        <el-col :span="12">
          <el-form-item :label-width="labelWidth" label="tdk所属模块" prop="tdk_type">
            <el-select disabled v-model="formData.tdk_type" clearable placeholder="请选择">
              <el-option v-for="item in tdk_type" :key="item.dictionary_guid" :label="item.dictionary_name"
                :value="item.dictionary_value"></el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item :label-width="labelWidth" label="语言类型" prop="i18n_lang_type">
            <el-select v-model="formData.i18n_lang_type_guid" clearable placeholder="请选择">
              <el-option v-for="item in i18n_lang_type" :key="item.i18n_lang_type_guid"
                :label="item.i18n_lang_type_code" :value="item.i18n_lang_type_guid"></el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="24">
          <el-form-item :label-width="labelWidth" label="网页标题" prop="tdk_title">
            <el-input v-model='formData.tdk_title' type="text" placeholder='请输入网页标题'></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="24">
          <el-form-item :label-width="labelWidth" label="网页简介" prop="tdk_description">
            <el-input v-model='formData.tdk_description' type="textarea" :rows="5" placeholder='请输入网页简介'></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="24">
          <el-form-item :label-width="labelWidth" label="网页关键词" prop="tdk_keyword">
            <el-input v-model='formData.tdk_keyword' type="textarea" :rows="5" placeholder='请输入网页关键词'></el-input>
          </el-form-item>
        </el-col>

      </el-row>
    </el-form>
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="handleEditClick(formRef)">保存</el-button>
        <el-button @click="handleResetClick(formRef)">重置</el-button>
        <el-button @click="closeDialog()">取消</el-button>
      </span>
    </template>
  </el-dialog>
</template>

<script setup>
import { reactive, ref, watch } from "vue";
import { editTdk, getDictionary } from "~/service/tdk";
import { useLoginStore } from "~/store";
import { getI18nLangTypeList } from '~/service/i18n_lang_type';

// --业务参数



// --业务方法

// 字典获取
const tdk_type = ref([]);
async function get_tdk_type() {
  await getDictionary({ dictionary_value: 'tdk_type' }).then((res) => {
    tdk_type.value = res
  })
}


// 语言类型code
const i18n_lang_type = ref();
async function geti18n_lang_typeList() {
  getI18nLangTypeList({ limit: 9999 }).then((res) => {
    if (res.code == 0) {
      i18n_lang_type.value = res.data
    }
  })
}

// --基础参数
const store = useLoginStore();
const headers = {
  Accept: "application/json",
  ...store.headers,
};
const formRef = ref();
const labelWidth = 100;
const props = defineProps({
  modelValue: Boolean,
  data: Object,
  done: Function,
});
const emits = defineEmits(["update:modelValue"]);
const formData = ref({
  ...props.data,
});
const uoloadData = ref({
  dirName: "Tdk"
})


// --基础方法
watch(props, (v) => {
  formData.value = v.data;


});

// 打开弹窗时执行
const openDialog = async () => {
  await get_tdk_type()
  await geti18n_lang_typeList()
};

const closeDialog = () => {
  props.done();
  emits("update:modelValue", false);
};

const rules = reactive({
  tdk_type: [
    {
      required: true,
      message: 'tdk所属模块不能为空'
    }
  ],
  tdk_title: [
    {
      required: true,
      message: '网页标题不能为空'
    }
  ],
  tdk_description: [
    {
      required: true,
      message: '网页简介不能为空'
    }
  ],
  tdk_keyword: [
    {
      required: true,
      message: '网页关键词不能为空'
    }
  ],

});

const handleEditClick = async (formEl) => {
  console.log(formData.value);
  if (!formEl) return;
  formEl.validate(async (valid) => {
    if (!valid) {
      return;
    }

    const { code } = await editTdk(formData.value);
    if (code == 0) {
      closeDialog();
      props.done();
    }
  });
};
const handleResetClick = async (formEl) => {
  if (!formEl) return;
  formEl.resetFields();
};
</script>

<style lang="less" scoped></style>
